Index: branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/TRD/trdmld_oce.F90
===================================================================
--- branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/TRD/trdmld_oce.F90	(revision 2612)
+++ branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/TRD/trdmld_oce.F90	(revision 2613)
@@ -71,5 +71,5 @@
       tmlatfm, smlatfm                !: accumulator for Asselin trends (needed for storage only)
 
-   REAL(wp), PUBLIC, DIMENSION(:,:,:) ::  &
+   REAL(wp), PUBLIC, ALLOCATABLE, DIMENSION(:,:,:) ::  &
       tmltrd,                       & !: \ physical contributions to the total trend (for T/S),
       smltrd,                       & !: / cumulated over the current analysis window
@@ -82,8 +82,8 @@
 #endif
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! NEMO/OPA 4.0 , NEMO Consortium (2011)
    !! $Id$ 
    !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
-   !!======================================================================
+   !!----------------------------------------------------------------------
 CONTAINS
 
@@ -92,5 +92,4 @@
      !!----------------------------------------------------------------------
      USE in_out_manager, ONLY: ctl_warn
-     IMPLICIT none
      INTEGER :: trdmld_oce_alloc
      INTEGER :: ierr(5)
@@ -104,40 +103,39 @@
 
 #if   defined  key_trdmld   ||   defined key_esopa
-     ALLOCATE(nmld(jpi,jpj), nbol(jpi,jpj),       &
-              wkx(jpi,jpj,jpk), rmld(jpi,jpj),    & 
-              tml(jpi,jpj)    , sml(jpi,jpj),     & 
-              tmlb(jpi,jpj)   , smlb(jpi,jpj) ,   &
-              tmlbb(jpi,jpj)  , smlbb(jpi,jpj),   &
-              Stat = ierr(1))
+     ALLOCATE( nmld(jpi,jpj), nbol(jpi,jpj),       &
+        &      wkx(jpi,jpj,jpk), rmld(jpi,jpj),    & 
+        &      tml(jpi,jpj)    , sml(jpi,jpj),     & 
+        &      tmlb(jpi,jpj)   , smlb(jpi,jpj) ,   &
+        &      tmlbb(jpi,jpj)  , smlbb(jpi,jpj),   &
+        &      Stat = ierr(1))
 
-     ALLOCATE(tmlbn(jpi,jpj)  , smlbn(jpi,jpj),   &
-              tmltrdm(jpi,jpj), smltrdm(jpi,jpj), &
-              tml_sum(jpi,jpj), tml_sumb(jpi,jpj),&
-              tmltrd_atf_sumb(jpi,jpj), Stat=ierr(2))
+     ALLOCATE( tmlbn(jpi,jpj)  , smlbn(jpi,jpj),   &
+        &      tmltrdm(jpi,jpj), smltrdm(jpi,jpj), &
+        &      tml_sum(jpi,jpj), tml_sumb(jpi,jpj),&
+        &      tmltrd_atf_sumb(jpi,jpj), Stat=ierr(2))
 
-     ALLOCATE(sml_sum(jpi,jpj), sml_sumb(jpi,jpj), &
-              smltrd_atf_sumb(jpi,jpj),            &
-              rmld_sum(jpi,jpj), rmldbn(jpi,jpj),  &
-              tmlatfb(jpi,jpj), tmlatfn(jpi,jpj),  & 
-              Stat = ierr(3))
+     ALLOCATE( sml_sum(jpi,jpj), sml_sumb(jpi,jpj), &
+        &      smltrd_atf_sumb(jpi,jpj),            &
+        &      rmld_sum(jpi,jpj), rmldbn(jpi,jpj),  &
+        &      tmlatfb(jpi,jpj), tmlatfn(jpi,jpj),  & 
+        &      Stat = ierr(3))
 
-     ALLOCATE(smlatfb(jpi,jpj), smlatfn(jpi,jpj), & 
-              tmlatfm(jpi,jpj), smlatfm(jpi,jpj), &
-              tmltrd(jpi,jpj,jpltrd),   smltrd(jpi,jpj,jpltrd), &
-              Stat=ierr(4))
+     ALLOCATE( smlatfb(jpi,jpj), smlatfn(jpi,jpj), & 
+        &      tmlatfm(jpi,jpj), smlatfm(jpi,jpj), &
+        &      tmltrd(jpi,jpj,jpltrd),   smltrd(jpi,jpj,jpltrd), &
+        &      Stat=ierr(4))
 
-     ALLOCATE(tmltrd_sum(jpi,jpj,jpltrd),tmltrd_csum_ln(jpi,jpj,jpltrd),      &
-              tmltrd_csum_ub(jpi,jpj,jpltrd), smltrd_sum(jpi,jpj,jpltrd),     &
-              smltrd_csum_ln(jpi,jpj,jpltrd), smltrd_csum_ub(jpi,jpj,jpltrd), &
-              Stat=ierr(5))
+     ALLOCATE( tmltrd_sum(jpi,jpj,jpltrd),tmltrd_csum_ln(jpi,jpj,jpltrd),      &
+        &      tmltrd_csum_ub(jpi,jpj,jpltrd), smltrd_sum(jpi,jpj,jpltrd),     &
+        &      smltrd_csum_ln(jpi,jpj,jpltrd), smltrd_csum_ub(jpi,jpj,jpltrd), &
+        &      Stat=ierr(5))
 #endif
+      !
+      trdmld_oce_alloc = MAXVAL(ierr)
+      !
+      IF( trdmld_oce_alloc /= 0 )   CALL ctl_warn('trdmld_oce_alloc: failed to allocate arrays.')
+      !
+   END FUNCTION trdmld_oce_alloc
 
-     trdmld_oce_alloc = MAXVAL(ierr)
-
-    IF(trdmld_oce_alloc /= 0)THEN
-       CALL ctl_warn('trdmld_oce_alloc: failed to allocate arrays.')
-    END IF
-
-  END FUNCTION trdmld_oce_alloc
-
+   !!======================================================================
 END MODULE trdmld_oce
Index: branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/TRD/trdmod.F90
===================================================================
--- branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/TRD/trdmod.F90	(revision 2612)
+++ branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/TRD/trdmod.F90	(revision 2613)
@@ -58,23 +58,22 @@
                           z2dx  => wrk_2d_5,  &
                           z2dy  => wrk_2d_6
-      IMPLICIT none
-      INTEGER, INTENT( in ) ::   kt                                ! time step
-      INTEGER, INTENT( in ) ::   ktrd                              ! tracer trend index
-      CHARACTER(len=3), INTENT( in ) ::   ctype                    ! momentum or tracers trends type 'DYN'/'TRA'
-      REAL(wp), DIMENSION(:,:,:), INTENT( inout ) ::   ptrdx ! Temperature or U trend 
-      REAL(wp), DIMENSION(:,:,:), INTENT( inout ) ::   ptrdy ! Salinity    or V trend
+      !
+      REAL(wp), DIMENSION(:,:,:), INTENT(inout) ::   ptrdx   ! Temperature or U trend 
+      REAL(wp), DIMENSION(:,:,:), INTENT(inout) ::   ptrdy   ! Salinity    or V trend
+      CHARACTER(len=3)          , INTENT(in   ) ::   ctype   ! momentum or tracers trends type 'DYN'/'TRA'
+      INTEGER                   , INTENT(in   ) ::   kt      ! time step
+      INTEGER                   , INTENT(in   ) ::   ktrd    ! tracer trend index
       !!
-      INTEGER ::   ji, jj
+      INTEGER ::   ji, jj   ! dummy loop indices
       !!----------------------------------------------------------------------
 
       IF(.not. wrk_use(2, 1,2,3,4,5,6))THEN
-         CALL ctl_error('trd_mod: Requested workspace arrays already in use.')
-         RETURN
+         CALL ctl_warn('trd_mod: Requested workspace arrays already in use.')   ;   RETURN
       END IF
 
-      z2dx(:,:)   = 0.e0   ;   z2dy(:,:)   = 0.e0                  ! initialization of workspace arrays
-
-      IF( neuler == 0 .AND. kt == nit000    ) THEN   ;   r2dt =      rdt      ! = rdtra (restarting with Euler time stepping)
-      ELSEIF(               kt <= nit000 + 1) THEN   ;   r2dt = 2. * rdt      ! = 2 rdttra (leapfrog)
+      z2dx(:,:) = 0._wp   ;   z2dy(:,:) = 0._wp                            ! initialization of workspace arrays
+
+      IF( neuler == 0 .AND. kt == nit000    ) THEN   ;   r2dt =      rdt   ! = rdtra (restart with Euler time stepping)
+      ELSEIF(               kt <= nit000 + 1) THEN   ;   r2dt = 2. * rdt   ! = 2 rdttra (leapfrog)
       ENDIF
 
@@ -94,15 +93,15 @@
             CASE ( jptra_trd_dmp )   ;   CALL trd_icp( ptrdx, ptrdy, jpicpt_dmp, ctype )   ! damping
             CASE ( jptra_trd_qsr )   ;   CALL trd_icp( ptrdx, ptrdy, jpicpt_qsr, ctype )   ! penetrative solar radiat.
-            CASE ( jptra_trd_nsr )   
-               z2dx(:,:) = ptrdx(:,:,1)   ;   z2dy(:,:) = ptrdy(:,:,1)
-               CALL trd_icp( z2dx, z2dy, jpicpt_nsr, ctype )                               ! non solar radiation
+            CASE ( jptra_trd_nsr )   ;   z2dx(:,:) = ptrdx(:,:,1)   
+                                         z2dy(:,:) = ptrdy(:,:,1)
+                                         CALL trd_icp( z2dx , z2dy , jpicpt_nsr, ctype )   ! non solar radiation
             CASE ( jptra_trd_xad )   ;   CALL trd_icp( ptrdx, ptrdy, jpicpt_xad, ctype )   ! x- horiz adv
             CASE ( jptra_trd_yad )   ;   CALL trd_icp( ptrdx, ptrdy, jpicpt_yad, ctype )   ! y- horiz adv
-            CASE ( jptra_trd_zad )                                                         ! z- vertical adv 
-               CALL trd_icp( ptrdx, ptrdy, jpicpt_zad, ctype )   
-               ! compute the surface flux condition wn(:,:,1)*tn(:,:,1)
-               z2dx(:,:) = wn(:,:,1)*tn(:,:,1)/fse3t(:,:,1)
-               z2dy(:,:) = wn(:,:,1)*sn(:,:,1)/fse3t(:,:,1)
-               CALL trd_icp( z2dx , z2dy , jpicpt_zl1, ctype )                             ! 1st z- vertical adv 
+            CASE ( jptra_trd_zad )   ;   CALL trd_icp( ptrdx, ptrdy, jpicpt_zad, ctype )   ! z- vertical adv 
+                                         CALL trd_icp( ptrdx, ptrdy, jpicpt_zad, ctype )   
+                                         ! compute the surface flux condition wn(:,:,1)*tn(:,:,1)
+                                         z2dx(:,:) = wn(:,:,1)*tn(:,:,1)/fse3t(:,:,1)
+                                         z2dy(:,:) = wn(:,:,1)*sn(:,:,1)/fse3t(:,:,1)
+                                         CALL trd_icp( z2dx , z2dy , jpicpt_zl1, ctype )   ! 1st z- vertical adv 
             END SELECT
          END IF
@@ -123,6 +122,6 @@
                ! subtract surface forcing/bottom friction trends 
                ! from vertical diffusive momentum trends
-               ztswu(:,:) = 0.e0   ;   ztswv(:,:) = 0.e0
-               ztbfu(:,:) = 0.e0   ;   ztbfv(:,:) = 0.e0  
+               ztswu(:,:) = 0._wp   ;   ztswv(:,:) = 0._wp
+               ztbfu(:,:) = 0._wp   ;   ztbfv(:,:) = 0._wp 
                DO jj = 2, jpjm1   
                   DO ji = fs_2, fs_jpim1   ! vector opt.
@@ -131,7 +130,6 @@
                      ztswv(ji,jj) = vtau(ji,jj) / ( fse3v(ji,jj,1)*rau0 )
                      ! bottom friction contribution now handled explicitly
-                     !
-                     ptrdx(ji,jj,1     ) = ptrdx(ji,jj,1     ) - ztswu(ji,jj)
-                     ptrdy(ji,jj,1     ) = ptrdy(ji,jj,1     ) - ztswv(ji,jj)
+                     ptrdx(ji,jj,1) = ptrdx(ji,jj,1) - ztswu(ji,jj)
+                     ptrdy(ji,jj,1) = ptrdy(ji,jj,1) - ztswv(ji,jj)
                   END DO
                END DO
@@ -228,7 +226,5 @@
       ENDIF
       !
-      IF(.not. wrk_release(2, 1,2,3,4,5,6))THEN
-         CALL ctl_error('trd_mod: Failed to release workspace arrays.')
-      END IF
+      IF( .not. wrk_release(2, 1,2,3,4,5,6) )   CALL ctl_warn('trd_mod: Failed to release workspace arrays.')
       !
    END SUBROUTINE trd_mod
@@ -242,5 +238,5 @@
    USE trdicp          ! ocean bassin integral constraints properties
    USE trdmld          ! ocean active mixed layer tracers trends 
-
+   !!----------------------------------------------------------------------
 CONTAINS
    SUBROUTINE trd_mod(ptrd3dx, ptrd3dy, ktrd , ctype, kt )   ! Empty routine
Index: branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfkpp.F90
===================================================================
--- branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfkpp.F90	(revision 2612)
+++ branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfkpp.F90	(revision 2613)
@@ -225,5 +225,6 @@
                           zustar => wrk_2d_3
       USE wrk_nemo, ONLY: zmask  => wrk_2d_4
-      USE wrk_nemo, ONLY: wrk_2d_5, wrk_2d_6, wrk_2d_7, wrk_2d_8, wrk_2d_9, &
+!gm      USE wrk_nemo, ONLY: wrk_2d_5, wrk_2d_6, wrk_2d_7, wrk_2d_8, wrk_2d_9, &
+      USE wrk_nemo, ONLY:           wrk_2d_6, wrk_2d_7, wrk_2d_8, wrk_2d_9, &
                           wrk_2d_10,wrk_2d_11
       USE wrk_nemo, ONLY: wrk_1d_1,  wrk_1d_2,  wrk_1d_3,  wrk_1d_4,  &
@@ -260,5 +261,6 @@
       REAL(wp) ::   zflag, ztemp, zrn2, zdep21, zdep32, zdep43
       REAL(wp) ::   zdku2, zdkv2, ze3sqr, zsh2, zri, zfri          ! Interior richardson mixing
-      REAL(wp), POINTER, DIMENSION(:,:) ::   zmoek                 ! Moning-Obukov limitation
+!gm      REAL(wp), POINTER, DIMENSION(:,:) ::   zmoek                 ! Moning-Obukov limitation
+      REAL(wp), DIMENSION(jpi,0:2) ::   zmoek                 ! Moning-Obukov limitation
       REAL(wp), POINTER, DIMENSION(:)   ::   zmoa, zekman                
       REAL(wp)                          ::   zmob, zek
@@ -285,5 +287,5 @@
       END IF
       ! Set-up pointers to 2D spaces
-      zmoek(1:jpi,0:2) => wrk_2d_5(1:jpi,1:3)
+!gm      zmoek(1:jpi,0:2) => wrk_2d_5(1:jpi,1:3)
       zdepw => wrk_2d_6(:,1:4)
       zdift => wrk_2d_7(:,1:4)
Index: branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfric.F90
===================================================================
--- branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfric.F90	(revision 2612)
+++ branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfric.F90	(revision 2613)
@@ -31,4 +31,5 @@
    PUBLIC   zdf_ric         ! called by step.F90
    PUBLIC   zdf_ric_init    ! called by opa.F90
+   PUBLIC   zdf_ric_alloc   ! called by nemogcm.F90
 
    LOGICAL, PUBLIC, PARAMETER ::   lk_zdfric = .TRUE.   !: Richardson vertical mixing flag
Index: branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90
===================================================================
--- branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90	(revision 2612)
+++ branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90	(revision 2613)
@@ -101,5 +101,5 @@
       !!              - finalize the run by closing files and communications
       !!
-      !! References : Madec, Delecluse,Imbard, and Levy, 1997:  internal report, IPSL.
+      !! References : Madec, Delecluse, Imbard, and Levy, 1997:  internal report, IPSL.
       !!              Madec, 2008, internal report, IPSL.
       !!----------------------------------------------------------------------
@@ -183,6 +183,6 @@
       !! ** Purpose :   initialization of the NEMO GCM
       !!----------------------------------------------------------------------
-      INTEGER ::   ji          ! dummy loop indices
-      INTEGER :: ilocal_comm   ! local integer
+      INTEGER ::   ji            ! dummy loop indices
+      INTEGER ::   ilocal_comm   ! local integer
       CHARACTER(len=80), DIMENSION(10) ::   cltxt
       !!
@@ -456,5 +456,4 @@
    END SUBROUTINE nemo_closefile
 
-   !!======================================================================
 
    SUBROUTINE nemo_alloc
@@ -462,37 +461,8 @@
      !!                     ***  ROUTINE nemo_alloc  ***
      !!
-     !! ** Purpose :   Allocate all the dynamic arrays in the modules
+     !! ** Purpose :   Allocate all the dynamic arrays of the OPA modules
      !!
      !! ** Method  :
-     !!
-     !! History :
-     !!   9.0  !  01-11  (A. R. Porter, STFC Daresbury)
      !!----------------------------------------------------------------------
-#if defined key_lim2
-     USE dom_ice_2,    ONLY: dom_ice_alloc_2
-     USE ice_2,        ONLY: ice_alloc_2
-     USE limdia_2,     ONLY: lim_dia_alloc_2
-     USE limhdf_2,     ONLY: lim_hdf_alloc_2
-     USE limsbc_2,     ONLY: lim_sbc_alloc_2
-     USE limwri_2,     ONLY: lim_wri_alloc_2
-     USE thd_ice_2,    ONLY: thd_ice_alloc_2
-#endif
-#if defined key_lim3 || (  defined key_lim2 && ! defined key_lim2_vp )
-     USE limrhg,       ONLY: lim_rhg_alloc
-#endif
-#if defined key_lim3
-     USE dom_ice,      ONLY: dom_ice_alloc
-     USE limitd_me,    ONLY: lim_itd_me_alloc
-     USE thd_ice,      ONLY: thd_ice_alloc
-#endif
-#if defined key_bdy 
-     USE bdy_oce,      ONLY: bdy_oce_alloc
-#endif
-#if defined key_diaar5
-     USE diaar5,       ONLY: dia_ar5_alloc
-#endif
-# if defined key_dimgout
-     USE diadimg,      ONLY: dia_wri_dimg_alloc
-#endif
 #if   defined key_diahth   ||   defined key_esopa
      USE diahth,       ONLY: dia_hth_alloc
@@ -549,7 +519,4 @@
      USE sbcdcy,       ONLY: sbc_dcy_alloc
      USE sbcfwb,       ONLY: sbc_fwb_alloc
-#if defined key_lim3 || defined key_lim2
-     USE sbc_ice,      ONLY: sbc_ice_alloc
-#endif
      USE sbc_oce,      ONLY: sbc_oce_alloc
      USE sbcrnf,       ONLY: sbc_rnf_alloc
@@ -575,254 +542,217 @@
      ! TOP-related alloc routines...
 #if defined key_top
-     USE trcadv,       ONLY: trc_adv_alloc
-     USE trc,          ONLY: trc_alloc
-     USE trcnxt,       ONLY: trc_nxt_alloc
-     USE trczdf,       ONLY: trc_zdf_alloc
-     USE trdmod_trc_oce,ONLY: trd_mod_trc_oce_alloc
+      USE trcadv,       ONLY: trc_adv_alloc
+      USE trc,          ONLY: trc_alloc
+      USE trcnxt,       ONLY: trc_nxt_alloc
+      USE trczdf,       ONLY: trc_zdf_alloc
+      USE trdmod_trc_oce,ONLY: trd_mod_trc_oce_alloc
 #endif
 #if defined key_top && ! defined key_iomput
-     USE trcdia,       ONLY: trc_dia_alloc
+      USE trcdia,       ONLY: trc_dia_alloc
 #endif
 #if  defined key_top && defined key_trcdmp 
-     USE trcdmp,       ONLY: trc_dmp_alloc
+      USE trcdmp,       ONLY: trc_dmp_alloc
 #endif
 #if  defined key_top  &&  defined key_dtatrc
-     USE trcdta,       ONLY: trc_dta_alloc
+      USE trcdta,       ONLY: trc_dta_alloc
 #endif
 #if   defined key_top && ( defined key_trdmld_trc   ||   defined key_esopa )
-     USE trdmld_trc,   ONLY: trd_mld_trc_alloc
-#endif
-     ! ...end of TOP-related alloc routines
-
-     ! LOBSTER-related alloc routines...
-     USE sms_lobster,  ONLY: sms_lobster_alloc
-     ! ...end of LOBSTER-related alloc routines
-
-     USE trc_oce,      ONLY: trc_oce_alloc
+      USE trdmld_trc,   ONLY: trd_mld_trc_alloc
+#endif
+      ! ...end of TOP-related alloc routines
+
+      ! LOBSTER-related alloc routines...
+      USE sms_lobster,  ONLY: sms_lobster_alloc
+      ! ...end of LOBSTER-related alloc routines
+
+      USE trc_oce,      ONLY: trc_oce_alloc
 #if   defined key_trdmld   ||   defined key_esopa
-     USE trdmld,       ONLY: trd_mld_alloc
-#endif
-     USE trdmld_oce,   ONLY: trdmld_oce_alloc
+      USE trdmld,       ONLY: trd_mld_alloc
+#endif
+      USE trdmld_oce,   ONLY: trdmld_oce_alloc
 #if  defined key_trdtra || defined key_trdmld || defined key_trdmld_trc 
-     USE trdtra,       ONLY: trd_tra_alloc
+      USE trdtra,       ONLY: trd_tra_alloc
 #endif
 #if defined key_trdvor   ||   defined key_esopa
-     USE trdvor,       ONLY: trd_vor_alloc
-#endif
-     USE wrk_nemo,     ONLY: wrk_alloc
-     USE zdfbfr,       ONLY: zdf_bfr_alloc
+      USE trdvor,       ONLY: trd_vor_alloc
+#endif
+      USE wrk_nemo,     ONLY: wrk_alloc
+      USE zdfbfr,       ONLY: zdf_bfr_alloc
 #if defined key_zdfddm   ||   defined key_esopa
-     USE zdfddm,       ONLY: zdf_ddm_alloc
+      USE zdfddm,       ONLY: zdf_ddm_alloc
 #endif
 #if defined key_zdfkpp   ||   defined key_esopa
-     USE zdfkpp,       ONLY: zdf_kpp_alloc
+      USE zdfkpp,       ONLY: zdf_kpp_alloc
 #endif
 #if defined key_zdfgls   ||   defined key_esopa
-     USE zdfgls,       ONLY: zdf_gls_alloc
-#endif
-     USE zdfmxl,       ONLY: zdf_mxl_alloc
-     USE zdf_oce,      ONLY: zdf_oce_alloc
+      USE zdfgls,       ONLY: zdf_gls_alloc
+#endif
+      USE zdfmxl,       ONLY: zdf_mxl_alloc
+      USE zdf_oce,      ONLY: zdf_oce_alloc
 #if defined key_zdfric   ||   defined key_esopa
-     USE zdfric,       ONLY: zdf_ric_alloc
+      USE zdfric,       ONLY: zdf_ric_alloc
 #endif
 #if defined key_zdftke   ||   defined key_esopa
-     USE zdftke,       ONLY: zdf_tke_alloc
+      USE zdftke,       ONLY: zdf_tke_alloc
 #endif
 #if defined key_zdftmx
-     USE zdftmx,       ONLY: zdf_tmx_alloc
-#endif
-     IMPLICIT none
-     INTEGER :: ierr
-     INTEGER :: i
-     !!----------------------------------------------------------------------
-
-     ierr = 0
-
-     !! Calls to the _alloc() routines should be in the same order as the 
-     !! modules are USE'd above
-#if defined key_lim2
-     ierr = ierr + dom_ice_alloc_2()
-     ierr = ierr + ice_alloc_2()
-     ierr = ierr + lim_dia_alloc_2()
-     ierr = ierr + lim_hdf_alloc_2()
-     ierr = ierr + lim_sbc_alloc_2()
-     ierr = ierr + lim_wri_alloc_2()
-     ierr = ierr + thd_ice_alloc_2()
-#endif
-#if defined key_lim3 || (  defined key_lim2 && ! defined key_lim2_vp )
-     ierr = ierr + lim_rhg_alloc()
-#endif
-#if defined key_lim3
-     ierr = ierr + dom_ice_alloc()
-     ierr = ierr + lim_itd_me_alloc()
-     ierr = ierr + thd_ice_alloc()
-#endif
-     ! End of ice-related allocations
-#if  defined key_bdy
-     ierr = ierr + bdy_oce_alloc()
-#endif
-#if defined key_diaar5
-     ierr = ierr + dia_ar5_alloc()
-#endif
-# if defined key_dimgout
-     ierr = ierr + dia_wri_dimg_alloc()
-#endif
-     ierr = ierr + div_cur_alloc()
+      USE zdftmx,       ONLY: zdf_tmx_alloc
+#endif
+      IMPLICIT none
+      INTEGER :: ierr
+      INTEGER :: i
+      !!----------------------------------------------------------------------
+
+      ierr = 0
+
+      !! Calls to the _alloc() routines should be in the same order as the 
+      !! modules are USE'd above
+      ! End of ice-related allocations
+      ierr = ierr + div_cur_alloc()
 #if   defined key_diahth   ||   defined key_esopa
-     ierr = ierr + dia_hth_alloc()
-#endif
-     ierr = ierr + dia_ptr_alloc()
-     ierr = ierr + dia_wri_alloc()
-     ierr = ierr + dom_oce_alloc()
+      ierr = ierr + dia_hth_alloc()
+#endif
+      ierr = ierr + dia_ptr_alloc()
+      ierr = ierr + dia_wri_alloc()
+      ierr = ierr + dom_oce_alloc()
 #if defined key_vvl
-     ierr = ierr + dom_vvl_alloc()
-#endif
-     ierr = ierr + dom_wri_alloc()
+      ierr = ierr + dom_vvl_alloc()
+#endif
+      ierr = ierr + dom_wri_alloc()
 #if defined key_dtasal   ||   defined key_esopa
-     ierr = ierr + dta_sal_alloc()
+      ierr = ierr + dta_sal_alloc()
 #endif
 #if defined key_ldfslp   ||   defined key_esopa
-     ierr = ierr + dyn_ldf_bilapg_alloc()
+      ierr = ierr + dyn_ldf_bilapg_alloc()
 #endif
 #if defined key_dtasal   ||   defined key_esopa
-     ierr = ierr + dta_sal_alloc()
+      ierr = ierr + dta_sal_alloc()
 #endif
 #if defined key_dtatem   ||   defined key_esopa
-     ierr = ierr + dta_tem_alloc()
+      ierr = ierr + dta_tem_alloc()
 #endif
 #if defined key_ldfslp   ||   defined key_esopa
-     ierr = ierr + dyn_ldf_iso_alloc()
+      ierr = ierr + dyn_ldf_iso_alloc()
 #endif
 #if   defined key_dynspg_ts   ||   defined key_vvl   ||   defined key_esopa
-     ierr = ierr + dynspg_oce_alloc()
-#endif
-     ierr = ierr + dyn_vor_alloc()
-     ierr = ierr + dyn_zdf_exp_alloc()
+      ierr = ierr + dynspg_oce_alloc()
+#endif
+      ierr = ierr + dyn_vor_alloc()
+      ierr = ierr + dyn_zdf_exp_alloc()
 #if   defined key_floats   ||   defined key_esopa
-     ierr = ierr + flo_oce_alloc()
+      ierr = ierr + flo_oce_alloc()
 #endif
 #if   defined key_floats   ||   defined key_esopa
-     ierr = ierr + flo_wri_alloc()
-#endif
-     ierr = ierr + geo2oce_alloc()
-     ierr = ierr + ldfdyn_oce_alloc()
+      ierr = ierr + flo_wri_alloc()
+#endif
+      ierr = ierr + geo2oce_alloc()
+      ierr = ierr + ldfdyn_oce_alloc()
 #if   defined key_ldfslp   ||   defined key_esopa
      ierr = ierr + ldf_slp_alloc()
 #endif
-     ierr = ierr + ldftra_oce_alloc()
+      ierr = ierr + ldftra_oce_alloc()
 #if defined key_mpp_mpi 
-     ierr = ierr + lib_mpp_alloc()
+      ierr = ierr + lib_mpp_alloc()
 #endif
 #if defined key_obc
-     ierr = ierr + obc_dta_alloc()
-     ierr = ierr + obc_oce_alloc()
-#endif
-     ierr = ierr + oce_alloc()
-     ierr = ierr + sbc_blk_clio_alloc()
+      ierr = ierr + obc_dta_alloc()
+      ierr = ierr + obc_oce_alloc()
+#endif
+      ierr = ierr + oce_alloc()
+      ierr = ierr + sbc_blk_clio_alloc()
 #if defined key_oasis3 || defined key_oasis4
-     ierr = ierr + sbc_cpl_init_alloc()
-#endif
-     ierr = ierr + sbc_dcy_alloc()
-     ierr = ierr + sbc_fwb_alloc()
-#if defined key_lim3 || defined key_lim2
-     ierr = ierr + sbc_ice_alloc()
-#endif
-     ierr = ierr + sbc_oce_alloc()
-     ierr = ierr + sbc_rnf_alloc()
-     ierr = ierr + sbc_ssr_alloc()
-     ierr = ierr + sol_oce_alloc()
-     ierr = ierr + sol_mat_alloc()
-     ierr = ierr + tra_adv_alloc()
-     ierr = ierr + tra_adv_cen2_alloc()
-#if   defined key_trabbl   ||   defined key_esopa
-     ierr = ierr + tra_bbl_alloc()
-#endif
-#if   defined key_tradmp   ||   defined key_esopa
-     ierr = ierr + tra_dmp_alloc()
-#endif
-     ierr = ierr + tra_ldf_alloc()
-#if   defined key_ldfslp   ||   defined key_esopa
-     ierr = ierr + tra_ldf_iso_grif_alloc()
-#endif
-     ierr = ierr + tra_ldf_lap_alloc()
-     ierr = ierr + tra_nxt_alloc()
-     ierr = ierr + tra_zdf_alloc()
-
-     ! Start of TOP-related alloc routines...
+      ierr = ierr + sbc_cpl_init_alloc()
+#endif
+      ierr = ierr + sbc_dcy_alloc()
+      ierr = ierr + sbc_fwb_alloc()
+      ierr = ierr + sbc_oce_alloc()
+      ierr = ierr + sbc_rnf_alloc()
+      ierr = ierr + sbc_ssr_alloc()
+      ierr = ierr + sol_oce_alloc()
+      ierr = ierr + sol_mat_alloc()
+      ierr = ierr + tra_adv_alloc()
+      ierr = ierr + tra_adv_cen2_alloc()
+#if defined key_trabbl   ||   defined key_esopa
+      ierr = ierr + tra_bbl_alloc()
+#endif
+#if defined key_tradmp   ||   defined key_esopa
+      ierr = ierr + tra_dmp_alloc()
+#endif
+      ierr = ierr + tra_ldf_alloc()
+#if defined key_ldfslp   ||   defined key_esopa
+      ierr = ierr + tra_ldf_iso_grif_alloc()
+#endif
+      ierr = ierr + tra_ldf_lap_alloc()
+      ierr = ierr + tra_nxt_alloc()
+      ierr = ierr + tra_zdf_alloc()
+
+      ! Start of TOP-related alloc routines...
 #if defined key_top
-     ierr = ierr + trc_adv_alloc()
-     ierr = ierr + trc_alloc()
-     ierr = ierr + trc_nxt_alloc()
-     ierr = ierr + trc_zdf_alloc()
-     ierr = ierr + trd_mod_trc_oce_alloc()
+      ierr = ierr + trc_adv_alloc()
+      ierr = ierr + trc_alloc()
+      ierr = ierr + trc_nxt_alloc()
+      ierr = ierr + trc_zdf_alloc()
+      ierr = ierr + trd_mod_trc_oce_alloc()
 #endif
 #if defined key_top && ! defined key_iomput
-     ierr = ierr + trc_dia_alloc()
+      ierr = ierr + trc_dia_alloc()
 #endif
 #if  defined key_top && defined key_trcdmp 
-     ierr = ierr + trc_dmp_alloc()
+      ierr = ierr + trc_dmp_alloc()
 #endif
 #if  defined key_top  &&  defined key_dtatrc
-     ierr = ierr + trc_dta_alloc()
+      ierr = ierr + trc_dta_alloc()
 #endif
 #if   defined key_top && ( defined key_trdmld_trc   ||   defined key_esopa )
-     ierr = ierr + trd_mld_trc_alloc()
-#endif
-     ! ...end of TOP-related alloc routines
-
-     ! Start of LOBSTER-related alloc routines
-     ierr = ierr + sms_lobster_alloc()
-     ! ...end of LOBSTER-related alloc routines
-
-     ierr = ierr + trc_oce_alloc()
+      ierr = ierr + trd_mld_trc_alloc()
+#endif
+      ! ...end of TOP-related alloc routines
+
+      ! Start of LOBSTER-related alloc routines
+      ierr = ierr + sms_lobster_alloc()
+      ! ...end of LOBSTER-related alloc routines
+
+      ierr = ierr + trc_oce_alloc()
 #if   defined key_trdmld   ||   defined key_esopa
-     ierr = ierr + trd_mld_alloc()
-#endif
-     ierr = ierr + trdmld_oce_alloc()
+      ierr = ierr + trd_mld_alloc()
+#endif
+      ierr = ierr + trdmld_oce_alloc()
 #if  defined key_trdtra || defined key_trdmld || defined key_trdmld_trc 
-     ierr = ierr + trd_tra_alloc()
+      ierr = ierr + trd_tra_alloc()
 #endif
 #if defined key_trdvor   ||   defined key_esopa
-     ierr = ierr + trd_vor_alloc()
-#endif
-     ierr = ierr + wrk_alloc()
-     ierr = ierr + zdf_bfr_alloc()
+      ierr = ierr + trd_vor_alloc()
+#endif
+      ierr = ierr + wrk_alloc()
+      ierr = ierr + zdf_bfr_alloc()
 #if defined key_zdfddm   ||   defined key_esopa
-     ierr = ierr + zdf_ddm_alloc()
+      ierr = ierr + zdf_ddm_alloc()
 #endif
 #if defined key_zdfkpp   ||   defined key_esopa
-     ierr = ierr + zdf_kpp_alloc()
+      ierr = ierr + zdf_kpp_alloc()
 #endif
 #if defined key_zdfgls   ||   defined key_esopa
-     ierr = ierr + zdf_gls_alloc()
-#endif
-     ierr = ierr + zdf_mxl_alloc()
-     ierr = ierr + zdf_oce_alloc()
+      ierr = ierr + zdf_gls_alloc()
+#endif
+      ierr = ierr + zdf_mxl_alloc()
+      ierr = ierr + zdf_oce_alloc()
 #if defined key_zdfric   ||   defined key_esopa
-     ierr = ierr + zdf_ric_alloc()
+      ierr = ierr + zdf_ric_alloc()
 #endif
 #if defined key_zdftke   ||   defined key_esopa
-     ierr = ierr + zdf_tke_alloc()
+      ierr = ierr + zdf_tke_alloc()
 #endif
 #if defined key_zdftmx
-     ierr = ierr + zdf_tmx_alloc()
-#endif
-
-     IF( lk_mpp ) CALL mpp_sum(ierr)
-
-     IF(ierr > 0)THEN
-        WRITE(numout,*) 
-        WRITE(numout,*) 'ERROR: Allocation of memory failed in nemo_alloc'
-        IF( lk_mpp ) CALL mppstop()
-        STOP
-     END IF
-
+      ierr = ierr + zdf_tmx_alloc()
+#endif
+
+      IF( lk_mpp    )   CALL mpp_sum(ierr)
+      IF( ierr /= 0 )   CALL ctl_stop( 'STOP', 'nemo_alloc : unable to allocate standard ocean arrays' )
+      !
    END SUBROUTINE nemo_alloc
 
-   !!======================================================================
-
-   SUBROUTINE nemo_partition(num_pes)
+
+   SUBROUTINE nemo_partition( num_pes )
      USE par_oce
-     IMPLICIT none
      INTEGER, INTENT(in) :: num_pes ! The number of MPI processes we have
      ! Local variables
